﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace ASPSMSX2_Demo_Application
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            verbose("Welcome " + wsc.VersionInfo() );

            wsc.Dispose();

            // load settings
            textBoxUserKey.Text = ASPSMSX2_Demo_Application.Properties.Settings.Default.UserKey;
            textBoxPassword.Text = ASPSMSX2_Demo_Application.Properties.Settings.Default.Password;

            textBoxStextOriginator.Text = ASPSMSX2_Demo_Application.Properties.Settings.Default.Originator;
            textBoxStokenOriginator.Text = ASPSMSX2_Demo_Application.Properties.Settings.Default.Originator;
            textBoxStextRecipients.Text = ASPSMSX2_Demo_Application.Properties.Settings.Default.Recipients;
            textBoxStokenRecipients.Text = ASPSMSX2_Demo_Application.Properties.Settings.Default.Recipients;
            textBoxStokenTokenReference.Text = ASPSMSX2_Demo_Application.Properties.Settings.Default.TokenReference;

            numericUpDownTokenValidity.Value = (int)ASPSMSX2_Demo_Application.Properties.Settings.Default.TokenValidity;
            numericUpDownTimeZone.Value = (int)ASPSMSX2_Demo_Application.Properties.Settings.Default.TimeZone;


            this.Text = "ASPSMSX2 Demo Application  (Build Version: " + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString() + ")";

        }

        private void buttonCheck_Click(object sender, EventArgs e)
        {
            verbose("Call CheckCredits");

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            string response = wsc.CheckCredits(textBoxUserKey.Text, textBoxPassword.Text);

            verbose("Response: " + response +" " + gscd(response));

            if (IsDouble(response.Replace("Credits:","")))
            {
                labelCredits.Text = response.Replace("Credits:","");
            }


            wsc.Dispose();


            ASPSMSX2_Demo_Application.Properties.Settings.Default.UserKey = textBoxUserKey.Text;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.Password = textBoxPassword.Text;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.Save();

        }
        
        /// <summary>
        /// GetStatusCodeDescription
        /// </summary>
        /// <param name="statusCode"></param>
        /// <returns></returns>
        private string gscd(string statusCode)
        {
            String retValue = "";
            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();
            retValue = wsc.GetStatusCodeDescription(statusCode);
            wsc.Dispose();
            return retValue;
        }

        private void verbose(string message)
        {
            textBoxLog.AppendText(message + "\r\n");
        
        }


        public static bool IsDouble(string theValue)
        {
            try
            {
                Convert.ToDouble(theValue);
                return true;
            }
            catch
            {
                return false;
            }
        }

        private void ButtonSendTextSMS_Click(object sender, EventArgs e)
        {
            verbose("Call SendTextSMS");

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            string response = wsc.SendTextSMS(textBoxUserKey.Text, textBoxPassword.Text, textBoxStextRecipients.Text,textBoxStextOriginator.Text,
                textBoxStextMessageText.Text,textBoxStextDeferredDeliveryTime.Text,checkBoxFlashingSMS.Checked.ToString(),numericUpDownTimeZone.Value.ToString(),
                textBoxStextURLB.Text,textBoxStextURLD.Text,textBoxStextURLN.Text,"");

            verbose("Response: " + response + " " + gscd(response));

            wsc.Dispose();


            ASPSMSX2_Demo_Application.Properties.Settings.Default.Originator = textBoxStextOriginator.Text;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.Recipients = textBoxStextRecipients.Text;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.TimeZone = (int)numericUpDownTimeZone.Value;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.Save();
        }

        private void buttonSendTokenSMS_Click(object sender, EventArgs e)
        {
            verbose("Call SendTokenSMS");

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            string response = wsc.SendTokenSMS(textBoxUserKey.Text, textBoxPassword.Text,textBoxStokenOriginator.Text,textBoxStokenRecipients.Text,
                textBoxStokenMessageText.Text,textBoxStokenTokenReference.Text,numericUpDownTokenValidity.Value.ToString(),textBoxStokenTokenMask.Text,
                textBoxStokenVerficationCode.Text,checkBoxStokenCaseSensitive.Checked.ToString(),
                textBoxStokenURLB.Text, textBoxStokenURLD.Text, textBoxStokenURLN.Text,"");

            verbose("Response: " + response + " " + gscd(response));

            wsc.Dispose();

            textBoxVTokenPhoneNumber.Text = textBoxStokenRecipients.Text;
            textBoxVTokenTokenRef.Text = textBoxStokenTokenReference.Text;
            textBoxVTokenVCode.Text = textBoxStokenVerficationCode.Text;

            ASPSMSX2_Demo_Application.Properties.Settings.Default.Originator = textBoxStokenOriginator.Text;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.Recipients = textBoxStokenRecipients.Text;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.TokenReference = textBoxStokenTokenReference.Text;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.TokenValidity = (int)numericUpDownTokenValidity.Value;
            ASPSMSX2_Demo_Application.Properties.Settings.Default.Save();
        }

        private void buttonVerifyToken_Click(object sender, EventArgs e)
        {
            verbose("Call VerifyToken");

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            string response = wsc.VerifyToken(textBoxUserKey.Text, textBoxPassword.Text, textBoxVTokenPhoneNumber.Text, textBoxVTokenTokenRef.Text, textBoxVTokenVCode.Text);

            verbose("Response: " + response + " " + gscd(response));

            wsc.Dispose();

        }

        private void buttonSendOriginatorUnlockCode_Click(object sender, EventArgs e)
        {
            verbose("Call SendOriginatorUnlockCode");

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            string response = wsc.SendOriginatorUnlockCode(textBoxUserKey.Text, textBoxPassword.Text, textBoxOrOr1.Text);

            verbose("Response: " + response + " " + gscd(response));

            wsc.Dispose();
        }

        private void buttonUnlockOriginator_Click(object sender, EventArgs e)
        {
            verbose("Call UnlockOriginator");

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            string response = wsc.UnlockOriginator(textBoxUserKey.Text, textBoxPassword.Text, textBoxOrOr2.Text,textBoxOrOriginatorUnlockCode.Text);

            verbose("Response: " + response + " " + gscd(response));

            wsc.Dispose();
        }

        private void buttonCheckOriginatorAuthorization_Click(object sender, EventArgs e)
        {
            verbose("Call CheckOriginatorAuthorization");

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            string response = wsc.CheckOriginatorAuthorization(textBoxUserKey.Text, textBoxPassword.Text, textBoxOrOr3.Text);

            verbose("Response: " + response + " " + gscd(response));

            wsc.Dispose();
        }

        private void buttonInquireDeliveryNotifications_Click(object sender, EventArgs e)
        {
            verbose("Call InquireDeliveryNotifications");

            ws.ASPSMSX2 wsc = new ws.ASPSMSX2();

            string response = wsc.InquireDeliveryNotifications(textBoxUserKey.Text, textBoxPassword.Text, textBoxTransactionReferenceNumbers.Text);

            verbose("Response: " + response + " " + gscd(response));

            wsc.Dispose();
        }

    }
}
